format PE GUI 4.0
entry start

include '..\..\include\win32a.inc'

struc PROCESSENTRY32
{
    .dwSize dd ?
    .cntUsage dd ?
    .th32ProcessID dd ?
    .th32DefaultHeapID dd ?
    .th32ModuleID dd ?
    .cntThreads dd ?
    .th32ParentProcessID dd ?
    .pcPriClassBase dd ?
    .dwFlags dd ?
    .szExeFile db MAX_PATH dup (?)
}

struc _LUID_AND_ATTRIBUTES
{
    .Luid dq ?
    .Attributes dd ?
}

struc _TOKEN_PRIVILEGES
{
    .PrivilegeCount dd ?
    .Privileges _LUID_AND_ATTRIBUTES
}

TH32CS_SNAPPROCESS  = $00000002;
TOKEN_QUERY = $0008;
TOKEN_ADJUST_PRIVILEGES = $0020;

SE_PRIVILEGE_ENABLED= $00000002;


CtrlAltDel_CODE = (VK_DELETE shl 16) or (MOD_CONTROL or MOD_ALT);
CtrlShiftEsc_CODE = (VK_ESCAPE shl 16) or (MOD_CONTROL or  MOD_SHIFT);

section '.remcode' code executable readable writeable
;----------------------------------------
; REMOTE CODE START ---------------------
;----------------------------------------
RemoteCodeStart:
    call .delta
   .delta:
    pop ebp
    sub ebp, .delta

    lea eax,  [ebp+SAS_WndTitle]
    push eax
    lea eax,  [ebp+SAS_WndClass]
    push eax
    call [ebp+pFindWindowA]
    mov [ebp+SAS_WndHandle], eax

    test eax, eax
    jnz @f
    jmp .thrend
   @@:
    lea eax, [ebp+NewWindowProc]
    push eax
    push GWL_WNDPROC
    push [ebp+SAS_WndHandle]
    call [ebp+pSetWindowLongA]
    mov [ebp+OldWindowProc], eax

    push 10000
    call [ebp+pSleep]

    push [ebp+OldWindowProc]
    push GWL_WNDPROC
    push [ebp+SAS_WndHandle]
    call [ebp+pSetWindowLongA]

   .thrend:
    push 0
    call [ebp+pExitThread]


proc NewWindowProc hwnd, wmsg, wparam, lparam
    call .delta
   .delta:
    pop eax
    sub eax, .delta ; delta offset -> eax

    cmp [wmsg], WM_HOTKEY
    jnz .continue

    cmp [lparam], CtrlAltDel_CODE
    jz .exit_proc
    cmp [lparam], CtrlShiftEsc_CODE
    jz .exit_proc

   .continue:
    push [lparam]
    push [wparam]
    push [wmsg]
    push [hwnd]
    push [eax+OldWindowProc]
    call [eax+pCallWindowProcA]
    jmp .return
   .exit_proc:
    xor eax, eax
   .return:
    ret
endp

SAS_WndClass db 'SAS Window class',0
SAS_WndTitle db 'SAS window',0
SAS_WndHandle dd 0
OldWindowProc dd 0

pFindWindowA	 dd 0
pSetWindowLongA  dd 0
pCallWindowProcA dd 0
pExitThread	 dd 0
pSleep		 dd 0

RemoteCodeEnd:
RemoteCodeSize equ RemoteCodeEnd-RemoteCodeStart
;----------------------------------------
; REMOTE CODE END -----------------------
;----------------------------------------

section '.code' code executable readable writeable

TokenPrivs _TOKEN_PRIVILEGES


SeDeugPriv db 'SeDebugPrivilege',0
winlogon_procname db 'winlogon.exe',0
proc_entry PROCESSENTRY32
pe_size:
PROCESSENTRY32_structsize equ pe_size-proc_entry

ProcessSnapshotHandle dd 0
WinlogonProcHandle dd 0
RemoteThreadBaseAddress dd 0
RemoteThreadID dd 0
TokenHandle dd 0

Writed dd 0


start:
    invoke GetCurrentProcess
    invoke OpenProcessToken, eax, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, TokenHandle
    invoke LookupPrivilegeValue, 0, SeDeugPriv,  TokenPrivs.Privileges.Luid
    mov [TokenPrivs.PrivilegeCount], 1
    mov [TokenPrivs.Privileges.Attributes], SE_PRIVILEGE_ENABLED;
    invoke AdjustTokenPrivileges, [TokenHandle], FALSE, TokenPrivs, 0, 0, 0

    test eax, eax
    jnz @f
    jmp .exit
   @@:
    ;debug privilege is enabled
    invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, 0
    mov [ProcessSnapshotHandle], eax

    mov [proc_entry.dwSize], PROCESSENTRY32_structsize

    invoke Process32First, eax, proc_entry
   .rep:
    invoke lstrcmpi, winlogon_procname, proc_entry.szExeFile
    cmp eax, 0
    jz .endrep
    invoke Process32Next, [ProcessSnapshotHandle], proc_entry
    jmp .rep
   .endrep:

    invoke OpenProcess, PROCESS_CREATE_THREAD or PROCESS_VM_OPERATION or PROCESS_VM_WRITE, FALSE, [proc_entry.th32ProcessID]
    mov [WinlogonProcHandle], eax

    test eax, eax
    jnz @f
    jmp .exit
   @@:

    mov eax, [FindWindow]
    mov [pFindWindowA], eax
    mov eax, [SetWindowLong]
    mov [pSetWindowLongA], eax
    mov eax, [ExitThread]
    mov [pExitThread], eax
    mov eax, [CallWindowProc]
    mov [pCallWindowProcA], eax
    mov eax, [Sleep]
    mov [pSleep], eax

    invoke VirtualAllocEx, [WinlogonProcHandle], 0, RemoteCodeSize, MEM_COMMIT+MEM_RESERVE, PAGE_EXECUTE_READWRITE
    mov [RemoteThreadBaseAddress], eax
    invoke WriteProcessMemory, [WinlogonProcHandle], eax, RemoteCodeStart, RemoteCodeSize, Writed
    invoke CreateRemoteThread, [WinlogonProcHandle], 0, 0, [RemoteThreadBaseAddress], 0, 0, RemoteThreadID

   .exit:
    invoke ExitProcess, 0


section '.relocs' fixups readable writeable

section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL',\
	  user, 'user32.dll',\
	  advapi, 'advapi32.dll'

  import advapi,\
	 OpenProcessToken,'OpenProcessToken',\
	 LookupPrivilegeValue, 'LookupPrivilegeValueA',\
	 AdjustTokenPrivileges,'AdjustTokenPrivileges'

  import kernel,\
	 ExitProcess,'ExitProcess', \
	 GetCommandLine,'GetCommandLineA',\
	 GetStdHandle, 'GetStdHandle',\
	 ReadConsole, 'ReadConsoleA',\
	 WriteConsole, 'WriteConsoleA',\
	 ExitThread, 'ExitThread',\
	 FormatMessage, 'FormatMessageA',\
	 Sleep, 'Sleep',\
	 VirtualAlloc,'VirtualAlloc',\
	 VirtualAllocEx,'VirtualAllocEx',\
	 CreateToolhelp32Snapshot, 'CreateToolhelp32Snapshot',\
	 Process32First,'Process32First',\
	 Process32Next,'Process32Next',\
	 lstrcmpi,'lstrcmpiA',\
	 OpenProcess, 'OpenProcess',\
	 WriteProcessMemory, 'WriteProcessMemory',\
	 CreateRemoteThread, 'CreateRemoteThread',\
	 GetCurrentProcess, 'GetCurrentProcess',\
	 GetLastError,'GetLastError'

  import user,\
	 MessageBox,'MessageBoxA',\
	 FindWindow, 'FindWindowA',\
	 SetWindowLong, 'SetWindowLongA',\
	 CallWindowProc, 'CallWindowProcA'