program loader;
uses
  Windows,SysUtils,Tlhelp32;

function SetDebugPriv: Boolean;
var
  Token: THandle;
  tkp: TTokenPrivileges;
begin
  Result := false;
  if OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, Token) then
  begin
   if LookupPrivilegeValue(nil, PChar('SeDebugPrivilege'), tkp.Privileges[0].Luid) then
    begin
     tkp.PrivilegeCount := 1;
     tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
     Result := AdjustTokenPrivileges(Token, false, tkp, 0, PTokenPrivileges(nil)^, PDWord(nil)^);
    end;
  end;
end;

function Start(ProcessID: Cardinal; DllFileName: string): Boolean;
var
  hProcess, hTh: THandle;
  BytesWritten, ThreadID, DllNameLen: Cardinal;
  LoadLibraryProc, MemPtr: Pointer;
  ExitCode: DWord;
begin
  Result := false;

  SetDebugPriv();

  hProcess := OpenProcess(PROCESS_CREATE_THREAD or PROCESS_VM_OPERATION or PROCESS_VM_WRITE,true, ProcessID);
  if hProcess = 0 then exit;

  DllNameLen := Length(DllFileName) + 1;
  MemPtr := VirtualAllocEx(hProcess, nil, DllNameLen, MEM_COMMIT, PAGE_READWRITE);
  if MemPtr <> nil then
   begin //3
    if WriteProcessMemory(hProcess, MemPtr, PChar(DllFileName), DllNameLen, BytesWritten) then
     begin //2
      LoadLibraryProc := GetProcAddress(GetModuleHandle('kernel32.dll'), 'LoadLibraryA');
      hTh := CreateRemoteThread(hProcess, nil, 0, LoadLibraryProc, MemPtr, 0, ThreadID);
      if hTh <> 0 then
       begin  //1
        if (WaitForSingleObject(hTh, INFINITE) = WAIT_OBJECT_0) and GetExitCodeThread(hTh, ExitCode) then
         Result := ExitCode <> 0;
        CloseHandle(hTh);
       end;  //1
     end; //2
    VirtualFreeEx(hProcess, MemPtr, 0, MEM_RELEASE);
   end;  //3
  CloseHandle(hProcess);
end;


var
  ProcessID: Cardinal;
  DllName,ppp: string;
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  ProcessID:=0;
  FSnapshotHandle:=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize:=Sizeof(FProcessEntry32);

  ContinueLoop := Process32First(FSnapshotHandle,FProcessEntry32);
  while integer(ContinueLoop) <> 0 do
   begin
    ppp:=FProcessEntry32.szExeFile;
    if (pos('WINLOGON',UpperCase(ppp))>0) then  ProcessID:=FProcessEntry32.th32ProcessID;
    ContinueLoop := Process32Next(FSnapshotHandle,  FProcessEntry32);
   end;
  CloseHandle(FSnapshotHandle);

  DllName:=ExtractFilePath(ParamStr(0))+'HookDLL.dll';
  if ProcessID <> 0 then Start(ProcessID, DllName);
end.
